//More information at: https://www.aeq-web.com/
//Sensor check for LoRa-Weatherstation 2020

#include <LoRa.h>
#include <SPI.h>

#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>

#define ss 18   //LoRa SS PIN
#define rst 14  //LoRa RST PIN
#define dio0 26 //LoRa DIO PIN

int ldrpin = 37; //PIN for LDR input
int anopin = 12; //PIN for anemometer input

float temp;
float pressure;
float humidity;
float sunlight;
float wind;

int wind_cnt;

Adafruit_BME280 bme;

void setup() {
  delay(5000);
  Serial.begin(115200);
  
  SPI.begin(5, 19, 27, 18);     //Pins for LoRa SPI
  LoRa.setPins(ss, rst, dio0);  //Pins for LoRa
  
  if (!LoRa.begin(868E6)) {
  Serial.println("Error: LoRa has not been initialized");
  }else{
  Serial.println("Success: LoRa has been initialized");
  }
  
  bme.begin(0x76); //define I2C-address
}

void loop() {
  getSensorData();

  Serial.print("Temp: ");
  Serial.print(temp);
  Serial.print(" *C Pressure: ");
  Serial.print(pressure);
  Serial.print(" hpa Humidity: ");
  Serial.print(humidity);
  Serial.print(" % Sun: ");
  Serial.print(sunlight);
  Serial.print(" % Wind: ");
  Serial.print(wind);
  Serial.println(" km/h");

  delay(1000);
}

void getSensorData() {
  temp = bme.readTemperature();
  pressure = bme.readPressure() / 100;
  humidity = bme.readHumidity();

  int LDRValue = analogRead(ldrpin);
  sunlight = (LDRValue * 0.02442);

  meassure_wind();
}

void meassure_wind() {
  wind_cnt = 0;
  attachInterrupt(digitalPinToInterrupt(anopin), intrrupt_cnt, RISING);
  delay(3000); //Time for measure counts
  detachInterrupt(digitalPinToInterrupt(anopin));
  wind = ((float)wind_cnt / (float)3 * 2.4) / 2; //Convert counts & time to km/h
}

void intrrupt_cnt() {//On count detected
  wind_cnt++;//Add one count
}
